XBEEONHSERIAL	con 1   ; try this version first...
; We will predefine these so we can add our own XBEE functions here to test...
cXBEE_IN				con	p14		; The input pin
cXBEE_OUT				con	p15		; the output pin

CXBEE_RTS				con	p7
#ifdef XBEEONHSERIAL
CXBEE_BAUD				con H62500				; Non-standard baud rate for xbee but...
#else
cXBEE_BAUD				con i57600				; now using standard serial
#endif	; XBEEONHSERIAL


; First lets define the Nodes.  For now lets do it quick and simple!
CMAXNDLIST	con	10						; currently the max number of nodes we will cache
CBNIMAX		con	12						; currently we will only keep 12 bytes per name
cNDList		var	byte					; how many items are in our list?
csNDList	var	byte					; checksum of data.
awNDMY		var	word(CMAXNDLIST)		; Keep a list of all of the Mys
alNDSNL		var	long(CMAXNDLIST)		; Serial numbers Low
alNDSNH		var	long(CMAXNDLIST)		; Serial Numbers High
abNDNIS		var	byte(CMAXNDLIST*CBNIMAX) ; keep all of the strings...
;==============================================================================
; [EEPROM] Define EEPROM memory locations
;==============================================================================
JoystickRangesDMStart	con	0x0		; 12 bytes - Stores Mins/Maxs of joysticks/sliders
XBeeDMStart				con	0x80	; 4 Bytes - Stores the XBee My and DL we want

XBeeNDDMCache			con	0x88	; 2 bytes - (count and checksum) How many items do we have cached out
									; followed by My array, SNL, SNH, and text strings... reserve 220 bytes for this!



cNodes	var	byte

	serout s_out, i9600, [13, 13, "XBee Test Program", 13]
main:
	gosub InitXBee

	gosub GetXBeeNDList[], cNodes
	serout s_out, i9600, ["Count of nodes: ", dec cNodes, 13]
	pause 5000
	goto main

;==============================================================================
; ReadSavedXBeeNDList - Read in the ND List that we have samed in the EEPROM.
;==============================================================================

_csin			var	byte
_i				var	byte
_j				var	byte
_bNDLT			var	byte(20)					; temporary string to read thigns into...
_cNDListIn		var	byte						; count of items that were read in from EEPROM
_wNDSS			var	word						; signal strength, don't care...
_fItemDup		var	bit							; Have we seen this item before?
_fListChanged	var	bit							; have we changed the list

ReadSavedXBeeNDList:
	_fListChanged = 0							; assume the list has not changed.    

    ; Ok Lets first read in the existing ones from the EEPROM
   	ReadDm	XBeeNDDMCache, [cNDList, csNDList]	; get count of items cached and checksum for them...
   	if (cNDList > 0) and (cNDList < CMAXNDLIST) then
   		; need to read in the data...
   		ReadDm XBeeNDDMCache+2, [str awNDMY\2*cNDList]						; Read in the my array 2 bytes per element...
   		ReadDm XBeeNDDMCache+2+ (2*CMAXNDLIST), [str alNDSNL\4*cNDList]		; read in SNL 4 bytes per element
   		ReadDm XBeeNDDMCache+2+ (6*CMAXNDLIST), [str alNDSNH\4*cNDList]		; read in SNH 4 bytes per element
   		ReadDm XBeeNDDMCache+2+ (10*CMAXNDLIST), [str abNDNIS\CBNIMAX*cNDList]		; read in Node Identifiers

    	; now lets compute the checksum
    	_csin = 0
    	for _i = 0 to cNDList-1 
    		 _csin = _csin + awNDMY(_i).lowbyte + awNDMY(_i).highbyte + alNDSNL(_i).byte0 + alNDSNL(_i).byte1 + alNDSNL(_i).byte2 + alNDSNL(_i).byte3
    		 _csin = _csin + alNDSNH(_i).byte0 + alNDSNH(_i).byte1 + alNDSNH(_i).byte2 + alNDSNH(_i).byte3
    	next
    	for _i = 0 to cndList*CBNIMAX - 1
    		_csin = _csin + abNDNIS(_i)
    	next
    	
    	; now validate the checksum...
    	if _csin <> csNDList then
    		cNDList = 0
    	endif
    endif
    return cNDList		; return how many we read in.
    
;==============================================================================
; SaveXBeeNDList - Save the XBeeNDList out to the EEPROM
;==============================================================================
SaveXBeeNDList:
	; First we need to compute the checksum
	; now lets compute the checksum
	_csin = 0
	if cNDList > 0 then
		for _i = 0 to cNDList-1 
			 _csin = _csin + awNDMY(_i).lowbyte + awNDMY(_i).highbyte + alNDSNL(_i).byte0 + alNDSNL(_i).byte1 + alNDSNL(_i).byte2 + alNDSNL(_i).byte3
			 _csin = _csin + alNDSNH(_i).byte0 + alNDSNH(_i).byte1 + alNDSNH(_i).byte2 + alNDSNH(_i).byte3
		next
		for _i = 0 to cndList*CBNIMAX - 1
			_csin = _csin + abNDNIS(_i)
		next
	endif
		
    ; Ok Lets first read in the existing ones from the EEPROM
   	WriteDm	XBeeNDDMCache, [cNDList, csNDList]	; get count of items cached and checksum for them...
   	if (cNDList > 0) and (cNDList < CMAXNDLIST) then
   		; need to read in the data...
   		WriteDm XBeeNDDMCache+2, [str awNDMY\2*cNDList]						; Read in the my array 2 bytes per element...
   		WriteDm XBeeNDDMCache+2+ (2*CMAXNDLIST), [str alNDSNL\4*cNDList]		; read in SNL 4 bytes per element
   		WriteDm XBeeNDDMCache+2+ (6*CMAXNDLIST), [str alNDSNH\4*cNDList]		; read in SNH 4 bytes per element
   		WriteDm XBeeNDDMCache+2+ (10*CMAXNDLIST), [str abNDNIS\CBNIMAX*cNDList]		; read in Node Identifiers
	endif
    return		; return how many we read in.
    
    
    
;==============================================================================
; ReadSavedXBeeNDList - Read in the ND List that we have samed in the EEPROM.
;==============================================================================
    
   _cNDListIn = cNDList	; remember how many we had from EEPROM (no need to check dups of items beyond this)
   ; now lets do the XBEE query and see if anything changes 
    gosub ClearInputBuffer				; make sure we toss everything out of our buffer and init the RTS pin
	pause 20							; have to have a guard time to get into Command sequence
#ifdef XBEEONHSERIAL
	hserout ["+++"]						; try to get it's attention
	gosub WaitHSeroutComplete
	pause 20							; have to wait a bit again

	hserout ["ATND", 13, 			|	; output the request for Node discovery.
			 "ATCN",13]					; Exit command mode
  	pause 10

	hserin 20000, _GNDL_Timeout, [str _bNDLT\20\13]	; read in the OK... Should confirm...

_GNDL_Loop:
	; Bugbug: should handle over running our buffers better
	if cNDList >= CMAXNDLIST then _GNDL_End		; bail before we over run something...
	hserin 3000000, _GNDL_TimeOut, [str _bNDLT\20\13]	; need to detect if empty or value...
	if _bndLT(0) = 13 then _GNDL_End	; end of our list
	
	gosub CHexString[@_bNDLT], awNDMY(cNDList)		; use the next free entry to store an item.
	
	hserin 200000, _GNDL_Timeout, [hex alNDSNH(cNDList), hex alNDSNL(cNDList), hex _wNDSS, str _bNDLT\20\13]
	
	serout s_out, i9600, [" MY:", hex awNDMY(cNDList), " SN:", hex alNDSNH(cNDList), hex alNDSNL(cNDList), "NI: ", str _bNDLT\20\13, 13]
	
	; now lets see if this is a duplicate of a cached item
	_fItemDup = 0
	if _cNDListIn then
		for _i = 0 to _cNDListIn-1
			if (alNDSNH(_i) = alNDSNH(cNDList)) and (alNDSNL(_i) = alNDSNL(cNDList)) then
				; We have seen this one before...
				_fItemDup = 1; 		; signal that this item is a duplicate...
	
				; but we will also make sure the MY or the NI has not changed.
				if (alNDSNH(_i) <> alNDSNH(cNDList)) then
					_fListChanged = 1; 	we know that we need to write the stuff back out...
					alNDSNH(_i) = alNDSNH(cNDList)
				endif
				for _j = 0 to CBNIMAX-1
					if abNDNIS(_i*CBNIMAX + _j) <> _bNDLT(_j) then
						abNDNIS(_i*CBNIMAX + _j) = _bNDLT(_j)
						_fListChanged = 1; 	we know that we need to write the stuff back out...
					endif
				next
			endif
		next
	endif
	hserin 3000000, _GNDL_TimeOut, [str _bNDLT\20\13]	; should be an empty string (cr only)
	if _fItemDup = 0 then
		for _j = 0 to CBNIMAX-1			; copy the NI string in.
			abNDNIS(cNDList*CBNIMAX + _j) = _bNDLT(_j)
		next
		cNDList = cNDList + 1
		_fListChanged = 1	; yes the list changed - have new node
	endif
	goto _GNDL_LOOP
_GNDL_Timeout:

_GNDL_End:
	return cNDList
#else
	serout cXBEE_OUT, cXBEE_BAUD,["+++"]						; try to get it's attention
	pause 20							; have to wait a bit again

	serout cXBEE_OUT, cXBEE_BAUD,["ATND", 13, |	; Do the node discovery
			 "ATCN",13]					; Exit command mode
	; first read should get back the OK<cr>
	i = 0 	; count of xbee nodes found
	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ;
	if _usdl_cbRead = 0 then _STDLN_NoMoreItems
	
_STDLN_ReceiveNextNode:
	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 3000000, 13], _usdl_cbRead ; read in MY - could be 2+ seconds
	if _usdl_cbread < 2 then _STDLN_NoMoreItems
	
	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ; read in SN High
	if _usdl_cbread < 2 then _STDLN_NoMoreItems
	
	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ; read in SN LOW
	if _usdl_cbread < 2 then _STDLN_NoMoreItems

	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ; read in strength
	if _usdl_cbread < 2 then _STDLN_NoMoreItems

	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ; read in NL
	if _usdl_cbread < 2 then _STDLN_NoMoreItems
	
	gosub TASerin[cXBEE_IN, cXBEE_RTS, cXBEE_BAUD, @bTemp,  20, 20000, 13], _usdl_cbRead ; read in NL
	if _usdl_cbread = 0  then _STDLN_NoMoreItems

#endif
	return

;==============================================================================
; CHexString[@_bNDLT], _wNDMY
;==============================================================================
_pstr	var	pointer
_lHex	var	long
CHexString[_pStr]:
	_lHex = 0

_CHS_Loop:	
	if (@_pstr >="0") and (@_pstr <= "9") then
		_lHex = _lHex * 16 + (@_pstr - "0")
	elseif (@_pstr >="a") and (@_pstr <= "f")
		_lHex = _lHex * 16 + (@_pstr - "a")
	elseif (@_pstr >="A") and (@_pstr <= "F")
		_lHex = _lHex * 16 + (@_pstr - "A")
	else 
		return _lHex
	endif
	_pStr = _pstr + 1
	goto _CHS_Loop


